#include "stdafx.h"
#include "RegManager.h"

#include "..//Solidgraph.h"

CRegisterManager::CRegisterManager(CSolidgraphApp* app):
						m_application(app)
{
	ASSERT(app);
	m_register_settings.interface_theme = CEGMenu::STYLE_ICY;
}

CRegisterManager::~CRegisterManager()
{
}

#define   SETTINGS_KEY                 _T("Settings")
#define   INTERFACE_THEME_VALUE        _T("InterfaceTheme")

bool CRegisterManager::LoadSettings()
{
	m_register_settings.interface_theme = m_application->GetProfileInt(SETTINGS_KEY, INTERFACE_THEME_VALUE, m_register_settings.interface_theme);
	return true;
}

bool CRegisterManager::SaveSettings()
{
	m_application->WriteProfileInt(SETTINGS_KEY, INTERFACE_THEME_VALUE, m_register_settings.interface_theme);
	return true;
}
